﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication2
{
    //public class Vector
    //{
    //    double x, y, z, sum;

    //    public Vector(double x, double y, double z)
    //    {
    //        this.x = x;
    //        this.y = y;
    //        this.z = z;
    //        this.sum = this.Abs();
    //    }

    //    public Vector(double x, double y)
    //    {
    //        this.x = x;
    //        this.y = y;
    //        z = 0.0;
    //        this.sum = this.Abs();
    //    }

    //    public double X { get { return x; } set { x = value; } }
    //    public double Y { get { return y; } set { y = value; } }
    //    public double Z { get { return z; } set { z = value; } }
    //    public double Sum { get { return sum; } set { sum = value; } }

    //    public double Abs()
    //    {
    //        return Math.Sqrt(x * x + y * y + z * z);
    //    }

    //    public static Vector operator +(Vector a, Vector b)
    //    {
    //        return new Vector(a.x + b.x, a.y + b.y, a.z + b.z);
    //    }

    //}

    public class Vect2D
    {
        public float X { get; set; }
        public float Y { get; set; }

        public float Length
        {
            get
            {
                return (float)Math.Sqrt(this.X * this.X + this.Y * this.Y);
            }

            set
            {
                float oldLen = this.Length;

                this.X *= value / oldLen;
                this.Y *= value / oldLen;
            }
        }
        public float Angle
        {
            get
            {
                return (float)Math.Atan2(this.Y, this.X);
            }

            set
            {
                double oldLen = this.Length;

                this.X = (float)(oldLen * Math.Cos(value));
                this.Y = (float)(oldLen * Math.Sin(value));
            }
        }

        public Vect2D(float x, float y)
        {
            this.X = x;
            this.Y = y;
        }

        public static Vect2D operator +(Vect2D a, Vect2D b)
        {
            return new Vect2D(a.X + b.X, a.Y + b.Y);
        }

        public static Vect2D operator -(Vect2D a, Vect2D b)
        {
            return new Vect2D(a.X - b.X, a.Y - b.Y);
        }

        public Vect2D GetNormal()
        {
            return new Vect2D(this.Y, -this.X);
        }

        public Vect2D GetCopy()
        {
            return new Vect2D(this.X, this.Y);
        }

        public PointF GetPointF()
        {
            return new PointF(this.X, this.Y);
        }
    }
}
